local _, private = ...;
local Gui = private.Gui;
local Bar = private.Gui.Bar;

Gui.dingerFrameTable = {
  name = "dingerFrame",
  type = "frame",
  height = 280,
  width = 300,
  hidden = true,
  backdrop = {
    bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background.png",
    edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border.png",
    tileSize = 0,
    edgeSize = 32,
    insets = {
      left = 8,
      right = 4,
      top = 4,
      bottom = 8,
    },
  },
  anchors = {
    TOPLEFT = {
      relativeTo = "SpellBookFrame",
      relativePoint = "TOPRIGHT",
      xOff = Gui.X_OFFSET,
      yOff = Gui.Y_OFFSET,
    },
  },
  scripts = {
    OnShow = function (...) Gui.DingerFrameOnShow(); end,
    OnHide = function (...) Gui.DingerFrameOnHide(); end,
  },
  children = {
    {
      name = "$parentHeader",
      type = "texture",
      texture = "Interface\\DialogFrame\\UI-DialogBox-Header.png",
      height = 64,
      width = 256,
      drawLayer = "ARTWORK",
      anchors = {
        CENTER = {
          relativeTo = "!$parent",
          relativePoint = "TOP",
          xOff = 0,
          yOff = -20,
        },
      },
    },
    {
      name = "$parentHeaderLogo",
      type = "texture",
      texture = "Interface\\AddOns\\dinger\\art\\logo.tga",
      drawLayer = "OVERLAY",
      height = 28,
      width = 128,
      color = {
        r = 0.99,
        g = 0.82,
        b = 0.00,
      },
      anchors = {
        CENTER = {
          relativeTo = "!$parent",
          relativePoint = "TOP",
          xOff = 0,
          yOff = -8,
        },
      },
    },
    {
      name = "dingerSpellIcon",
      type = "button",
      scale = 2,
      inheritsFrom = "ActionButtonTemplate",
      scripts = {
        OnClick = function (...) Gui.SpellIconOnClick(...); end,
      },
      anchors = {
        TOP = {
          relativeTo = "!$parent",
          relativePoint = "TOP",
          xOff = 0,
          yOff = -20,
        },
      },
      children = {
        {
          name = "$parentTexture",
          type = "texture",
          drawLayer = "BACKGROUND",
          anchors = {
            allPoints = true;
          },
        },
        {
          name = "$parentText",
          type = "fontstring",
          height = 20,
          width = 100,
          inheritsFrom = "GameFontNormal",
          justifyH = "CENTER",
          justifyV = "TOP",
          fontHeight = 8,
          anchors = {
            TOP = {
              relativeTo = "!$parent",
              relativePoint = "BOTTOM",
              xOff = 0,
              yOff = -4,
            },
          },
        },
      },
    },
    {
      name = "dingerClearButton",
      type = "button",
      height = 64,
      width = 32,
      normalTexture = "Interface\\AddOns\\dinger\\art\\TrashCanUp.tga",
      pushedTexture = "Interface\\AddOns\\dinger\\art\\TrashCanDown.tga",
      highlightTexture = "Interface\\BUTTONS\\UI-MicroButton-Hilight.png",
      disabledTexture = "Interface\\AddOns\\dinger\\art\\TrashCanDisabled.tga",
      highlightMode = "ADD",
      scripts = {
        OnClick = function (...) Bar.Clear(); end,
      },
      anchors = {
        TOPRIGHT = {
          relativeTo = "!dingerFrame",
          relativePoint = "TOPRIGHT",
          xOff = -20,
          yOff =  5,
        },
      },
    },
  },
};