local RecyclerInstance = {};

local freeTables = {};
local usedTables = {};
local createFunctions = {};

function RecyclerInstance:Get (...)
  local value = next(freeTables[self]);
  if not value then
    value = createFunctions[self](...);
  else
    freeTables[self][value] = nil;
  end

  usedTables[self][value] = true;
  
  return value;
end

function RecyclerInstance:Free (value)
  freeTables[self][value] = true;
  usedTables[self][value] = nil;
end

Recycler = {};

 local RecyclerMetatable = { __index = RecyclerInstance };

function Recycler:New (createFunction)
  local instance = setmetatable({}, RecyclerMetatable);
  
  freeTables[instance] = {};
  usedTables[instance] = {};
  createFunctions[instance] = createFunction;
  
  return instance;
end
